# ***** BEGIN LICENSE BLOCK *****
# * Copyright (C) 2007  Alexey Gladkov <legion@altlinux.org>
# *
# * This program is free software; you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation; either version 2 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
# ***** END LICENSE BLOCK *****

. alterator-hw-functions

add_others(){
  # Add all other systems fo conf.
  # For initial configuration
  while read dev label; do
    printf 'other="%s"\nlabel="%s"\n' "$dev" "$label"
  done
}

add_kernels(){
  # Add all kernels fo conf (if there are more then one kernel).
  [ "$(find /boot -name 'vmlinuz-*' | wc -l)" -gt 1 ] || return 0

  for i in $(find /boot -name 'vmlinuz-*' | sort -r); do
    local ver="${i#/boot/vmlinuz-}"
    local initrd="/boot/initrd-$ver.img"

    # maximal length of the label is 19 chars
    local label="$(printf "%s" "$ver" |
      sed -e 's/\.//g; # substitutions from bootloader-utils
              s/mdk\|alt//;
              s/secure/sec/;
              s/enterprise/ent/;
              s/vanilla/vnl/;')"
    printf "image=\"%s\"\n" "$i"
    printf "label=\"%s\"\n" "$label"
    [ ! -f "$initrd" ] ||
      printf "initrd=\"%s\"\n" "$initrd"
    printf "root=\"\"\n"
    printf "read-only\n"
    printf "\n"
  done
}

list_others(){
  local cnf="$1"
  while read sym label; do
    local newlabel=$(test_other_section "$sym" "$cnf")
    label=${newlabel:-$label}
    local enabled='on'
    local dev=$(blockdev_follow_symlink $sym)
    [ -z "$newlabel" ] && enabled='off'
    _write_begin
    write_string_param "name"       "$sym"
    write_string_param "label"      "$label"
    write_string_param "long_label" "$label (`_ "partition"` ${dev##*/})"
    write_bool_param   "enabled"    "$enabled"
    _write_end
  done
}

