(document:surround "/std/frame")

;;; Functions

(define (ui-write)
  (catch/message
    (lambda()
      (apply woo-write "/lilo/source"
	     (form-value-list '("source" "liloopts"))))))

(define (ui-commit)
  (and (ui-write)
       (catch/message
	 (lambda()
	   (woo-write "/lilo/commit" 'confonly (form-value "confonly"))))))

(define (ui-read)
  (catch/message
    (lambda()
      (form-update-value-list
	'("source" "liloopts")
	(woo-read-first "/lilo/source")))))

(define (ui-change url)
  (and (ui-write) (frame:replace url)))

(define (ui-simple)
  (ui-change "/lilo"))

(define (ui-expert)
  (ui-change "/lilo/expert"))

;;; UI

(gridbox
  columns "0;100;0;0;0"
  align "top"
  (checkbox text (_ "Don't install bootloader") name "confonly" value #f)
  (spacer)
  (button text (_ "Simple mode") name "simple_button")
  (button text (_ "Expert mode") name "expert_button")
  (button text (_ "Edit lilo.conf") activity #f))

(textbox name "source")

(gridbox
  columns "0;100"
  align "bottom"
  (label text (_ "Lilo options:"))
  (edit name "liloopts"))

(or (global 'frame:next)
    (gridbox
      columns "50;0;0;50"
      align "top"
      (spacer)
      (button text (_ "Apply") name "apply_button")
      (button text (_ "Reset") name "reset_button")
      (spacer)))

(and (global 'frame:next)
     (frame:on-next (lambda() (or (ui-commit) 'cancel))))

;;; Init

(document:root
  (when loaded
    (ui-read)
    (form-bind "simple_button" "click" ui-simple)
    (form-bind "expert_button" "click" ui-expert)
    (or (global 'frame:next) (form-bind "apply_button" "click" ui-commit))
    (or (global 'frame:next) (form-bind "reset_button" "click" ui-read))
    (and (global 'frame:next) (frame:back-activity #f))))
